Index: /NEMO/branches/2020/tickets_icb_1900/src/ICE/icethd_pnd.F90
===================================================================
--- /NEMO/branches/2020/tickets_icb_1900/src/ICE/icethd_pnd.F90	(revision 14015)
+++ /NEMO/branches/2020/tickets_icb_1900/src/ICE/icethd_pnd.F90	(revision 14016)
@@ -20,6 +20,8 @@
    USE ice1D          ! sea-ice: thermodynamics variables
    USE icetab         ! sea-ice: 1D <==> 2D transformation
+   USE sbc_ice        ! surface energy budget
    !
    USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
    USE lib_fortran    ! fortran utilities (glob_sum + no signed zero)
@@ -34,8 +36,32 @@
    INTEGER ::              nice_pnd    ! choice of the type of pond scheme
    !                                   ! associated indices:
-   INTEGER, PARAMETER ::   np_pndNO  = 0   ! No pond scheme
-   INTEGER, PARAMETER ::   np_pndCST = 1   ! Constant ice pond scheme
-   INTEGER, PARAMETER ::   np_pndLEV = 2   ! Level ice pond scheme
-
+   INTEGER, PARAMETER ::   np_pndNO   = 0   ! No pond scheme
+   INTEGER, PARAMETER ::   np_pndCST  = 1   ! Constant ice pond scheme
+   INTEGER, PARAMETER ::   np_pndLEV  = 2   ! Level ice pond scheme
+   INTEGER, PARAMETER ::   np_pndTOPO = 3   ! Level ice pond scheme
+
+   !-------------------------------------------------------------------------- 
+   ! Diagnostics for pond volume per area
+   !
+   ! dV/dt = mlt + drn + lid + rnf
+   ! mlt   = input from surface melting
+   ! drn   = drainage through brine network
+   ! lid   = lid growth & melt
+   ! rnf   = runoff (water directly removed out of surface melting + overflow)
+   !
+   ! In topo mode, the pond water lost because it is in the snow is not included in the budget
+   ! In level mode, all terms are incorporated
+   !
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   diag_dvpn_mlt       ! meltwater pond volume input      [kg/m2/s]
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   diag_dvpn_drn       ! pond volume lost by drainage     [-]
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   diag_dvpn_lid       ! exchange with lid / refreezing   [-]
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   diag_dvpn_rnf       ! meltwater pond lost to runoff    [-]      
+   REAL(wp), ALLOCATABLE, DIMENSION(:)   ::   diag_dvpn_mlt_1d    ! meltwater pond volume input      [-]
+   REAL(wp), ALLOCATABLE, DIMENSION(:)   ::   diag_dvpn_drn_1d    ! pond volume lost by drainage     [-]
+   REAL(wp), ALLOCATABLE, DIMENSION(:)   ::   diag_dvpn_lid_1d    ! exchange with lid / refreezing   [-]
+   REAL(wp), ALLOCATABLE, DIMENSION(:)   ::   diag_dvpn_rnf_1d    ! meltwater pond lost to runoff    [-]
+
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/ICE 4.0 , NEMO Consortium (2018)
@@ -46,19 +72,81 @@
 
    SUBROUTINE ice_thd_pnd
+
       !!-------------------------------------------------------------------
       !!               ***  ROUTINE ice_thd_pnd   ***
       !!               
       !! ** Purpose :   change melt pond fraction and thickness
-      !!                
+      !!
+      !! ** Note    : Melt ponds affect only radiative transfer for now
+      !!              No heat, no salt.
+      !!              The current diagnostics lacks a contribution from drainage
       !!-------------------------------------------------------------------
+      INTEGER ::   ji, jj, jl        ! loop indices
+      !!-------------------------------------------------------------------
+      
+      ALLOCATE( diag_dvpn_mlt(jpi,jpj), diag_dvpn_lid(jpi,jpj), diag_dvpn_drn(jpi,jpj), diag_dvpn_rnf(jpi,jpj) )
+      ALLOCATE( diag_dvpn_mlt_1d(jpij), diag_dvpn_lid_1d(jpij), diag_dvpn_drn_1d(jpij), diag_dvpn_rnf_1d(jpij) )
       !
-      SELECT CASE ( nice_pnd )
+      diag_dvpn_mlt (:,:) = 0._wp   ;   diag_dvpn_drn (:,:) = 0._wp
+      diag_dvpn_lid (:,:) = 0._wp   ;   diag_dvpn_rnf (:,:) = 0._wp
+      diag_dvpn_mlt_1d(:) = 0._wp   ;   diag_dvpn_drn_1d(:) = 0._wp
+      diag_dvpn_lid_1d(:) = 0._wp   ;   diag_dvpn_rnf_1d(:) = 0._wp
+
+      !-------------------------------------
+      !  Remove ponds where ice has vanished
+      !-------------------------------------
+      at_i(:,:) = SUM( a_i, dim=3 )
       !
-      CASE (np_pndCST)   ;   CALL pnd_CST    !==  Constant melt ponds  ==!
-         !
-      CASE (np_pndLEV)   ;   CALL pnd_LEV    !==  Level ice melt ponds  ==!
-         !
-      END SELECT
+      DO jl = 1, jpl
+         DO_2D( 1, 1, 1, 1 )
+            IF( v_i(ji,jj,jl) < epsi10 .OR. at_i(ji,jj) < epsi10 ) THEN
+               wfx_pnd  (ji,jj)    = wfx_pnd(ji,jj) + ( v_ip(ji,jj,jl) + v_il(ji,jj,jl) ) * rhow * r1_Dt_ice
+               a_ip     (ji,jj,jl) = 0._wp
+               v_ip     (ji,jj,jl) = 0._wp
+               v_il     (ji,jj,jl) = 0._wp
+               h_ip     (ji,jj,jl) = 0._wp
+               h_il     (ji,jj,jl) = 0._wp
+               a_ip_frac(ji,jj,jl) = 0._wp
+            ENDIF
+         END_2D
+      END DO
+      
+      !------------------------------
+      !  Identify grid cells with ice
+      !------------------------------
+      npti = 0   ;   nptidx(:) = 0
+      DO_2D( 1, 1, 1, 1 )
+         IF( at_i(ji,jj) >= epsi10 ) THEN
+            npti = npti + 1
+            nptidx( npti ) = (jj - 1) * jpi + ji
+         ENDIF
+      END_2D
+
+      !------------------------------------
+      !  Select melt pond scheme to be used
+      !------------------------------------
+      IF( npti > 0 ) THEN
+         SELECT CASE ( nice_pnd )
+            !
+         CASE (np_pndCST)   ;   CALL pnd_CST                              !==  Constant melt ponds  ==!
+            !
+         CASE (np_pndLEV)   ;   CALL pnd_LEV                              !==  Level ice melt ponds  ==!
+            !
+         CASE (np_pndTOPO)  ;   CALL pnd_TOPO                             !==  Topographic melt ponds  ==!
+            !
+         END SELECT
+      ENDIF
+
+      !------------------------------------
+      !  Diagnostics
+      !------------------------------------
+      CALL iom_put( 'dvpn_mlt', diag_dvpn_mlt ) ! input from melting
+      CALL iom_put( 'dvpn_lid', diag_dvpn_lid ) ! exchanges with lid
+      CALL iom_put( 'dvpn_drn', diag_dvpn_drn ) ! vertical drainage
+      CALL iom_put( 'dvpn_rnf', diag_dvpn_rnf ) ! runoff + overflow
       !
+      DEALLOCATE( diag_dvpn_mlt   , diag_dvpn_lid   , diag_dvpn_drn   , diag_dvpn_rnf    )
+      DEALLOCATE( diag_dvpn_mlt_1d, diag_dvpn_lid_1d, diag_dvpn_drn_1d, diag_dvpn_rnf_1d )
+      
    END SUBROUTINE ice_thd_pnd 
 
@@ -80,18 +168,45 @@
       !! ** References : Bush, G.W., and Trump, D.J. (2017)
       !!-------------------------------------------------------------------
-      INTEGER  ::   ji        ! loop indices
+      INTEGER  ::   ji, jl    ! loop indices
+      REAL(wp) ::   zdv_pnd   ! Amount of water going into the ponds & lids
       !!-------------------------------------------------------------------
-      DO ji = 1, npti
-         !
-         IF( a_i_1d(ji) > 0._wp .AND. t_su_1d(ji) >= rt0 ) THEN
-            h_ip_1d(ji)      = rn_hpnd    
-            a_ip_1d(ji)      = rn_apnd * a_i_1d(ji)
-            h_il_1d(ji)      = 0._wp    ! no pond lids whatsoever
-         ELSE
-            h_ip_1d(ji)      = 0._wp    
-            a_ip_1d(ji)      = 0._wp
-            h_il_1d(ji)      = 0._wp
-         ENDIF
-         !
+      DO jl = 1, jpl
+         
+         CALL tab_2d_1d( npti, nptidx(1:npti), a_i_1d    (1:npti), a_i    (:,:,jl) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), t_su_1d   (1:npti), t_su   (:,:,jl) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), a_ip_1d   (1:npti), a_ip   (:,:,jl) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), h_ip_1d   (1:npti), h_ip   (:,:,jl) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), h_il_1d   (1:npti), h_il   (:,:,jl) )
+         CALL tab_2d_1d( npti, nptidx(1:npti), wfx_pnd_1d(1:npti), wfx_pnd(:,:)    )
+
+         DO ji = 1, npti
+            !
+            zdv_pnd = ( h_ip_1d(ji) + h_il_1d(ji) ) * a_ip_1d(ji)
+            !
+            IF( a_i_1d(ji) >= 0.01_wp .AND. t_su_1d(ji) >= rt0 ) THEN
+               h_ip_1d(ji)      = rn_hpnd    
+               a_ip_1d(ji)      = rn_apnd * a_i_1d(ji)
+               h_il_1d(ji)      = 0._wp    ! no pond lids whatsoever
+            ELSE
+               h_ip_1d(ji)      = 0._wp    
+               a_ip_1d(ji)      = 0._wp
+               h_il_1d(ji)      = 0._wp
+            ENDIF
+            !
+            v_ip_1d(ji) = h_ip_1d(ji) * a_ip_1d(ji)
+            v_il_1d(ji) = h_il_1d(ji) * a_ip_1d(ji)
+            !
+            zdv_pnd = ( h_ip_1d(ji) + h_il_1d(ji) ) * a_ip_1d(ji) - zdv_pnd
+            wfx_pnd_1d(ji) = wfx_pnd_1d(ji) - zdv_pnd * rhow * r1_Dt_ice
+            !
+         END DO
+
+         CALL tab_1d_2d( npti, nptidx(1:npti), a_ip_1d   (1:npti), a_ip   (:,:,jl) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), h_ip_1d   (1:npti), h_ip   (:,:,jl) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), h_il_1d   (1:npti), h_il   (:,:,jl) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), v_ip_1d   (1:npti), v_ip   (:,:,jl) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), v_il_1d   (1:npti), v_il   (:,:,jl) )
+         CALL tab_1d_2d( npti, nptidx(1:npti), wfx_pnd_1d(1:npti), wfx_pnd(:,:)    )
+
       END DO
       !
@@ -132,9 +247,10 @@
       !!                    if no lids:   Vp = Vp * exp(0.01*MAX(Tp-Tsu,0)/Tp)                      --- from Holland et al 2012 ---
       !!
-      !!              - Flushing:         w = -perm/visc * rho_oce * grav * Hp / Hi                 --- from Flocco et al 2007 ---
-      !!                                     perm = permability of sea-ice
+      !!              - Flushing:         w = -perm/visc * rho_oce * grav * Hp / Hi * flush         --- from Flocco et al 2007 ---
+      !!                                     perm = permability of sea-ice                              + correction from Hunke et al 2012 (flush)
       !!                                     visc = water viscosity
       !!                                     Hp   = height of top of the pond above sea-level
       !!                                     Hi   = ice thickness thru which there is flushing
+      !!                                     flush= correction otherwise flushing is excessive
       !!
       !!              - Corrections:      remove melt ponds when lid thickness is 10 times the pond thickness
@@ -143,12 +259,13 @@
       !!                                  a_ip/a_i = a_ip_frac = h_ip / zaspect
       !!
-      !! ** Tunable parameters : ln_pnd_lids, rn_apnd_max, rn_apnd_min
+      !! ** Tunable parameters : rn_apnd_max, rn_apnd_min, rn_pnd_flush
       !! 
-      !! ** Note       :   mostly stolen from CICE
+      !! ** Note       :   Mostly stolen from CICE but not only. These are between level-ice ponds and CESM ponds. 
       !!
       !! ** References :   Flocco and Feltham (JGR, 2007)
       !!                   Flocco et al       (JGR, 2010)
       !!                   Holland et al      (J. Clim, 2012)
-      !!-------------------------------------------------------------------
+      !!                   Hunke et al        (OM 2012)
+      !!-------------------------------------------------------------------  
       REAL(wp), DIMENSION(nlay_i) ::   ztmp           ! temporary array
       !!
